﻿function PVPSound_OnLoad()
	PVPSound_frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	PVPSound_frame:RegisterEvent("PLAYER_DEAD");
	PVPSound_frame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	PVPSound_frame:RegisterEvent("ADDON_LOADED");
	PVPSound_frame:RegisterEvent("PLAYER_LOGOUT");

-- Slash Commands --
	SlashCmdList["PVPSound"] = PVPSound_Command;
		SLASH_PVPSound1 = "/pvpsound";
		SLASH_PVPSound2 = "/psd";
end

PVPSound_frame = CreateFrame("FRAME", "PVPSound_Frame");
--addon:SetScript('OnEvent', function(self, event, ...) self[event](self, ...) end);

local total = 0
function PVPSound_frame:OnUpdate(elps)
	total = total + elps
	if total >= 2 then
		PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..PS_file_m);
		total = 0
		PVPSound_frame:SetScript('OnUpdate', nil)
	end
end

	local PS_timer_reset = false;
	local PS_reset_time = 1800;
	local PS_mkill_time = 11.5;
	PS_showemote = false;
	local PS_showemote_init = PS_showemote;
	PS_pvpmode = true;
	local PS_pvpmode_init = PS_pvpmode;
	local PS_kills = 0;
	local enemyname = nil;

function PVPSound_OnEvent(self, event,...)
    local player = UnitGUID("player")
    local pname = UnitName("player")
	local arg1, eventType, hideCaster, srcGUID, srcName, sourceFlags, sourceRaidFlags, destGUID, dstName, dstFlags, destRaidFlags = select(1, ...)
	local CombatLog_Object_IsA = CombatLog_Object_IsA
	local COMBATLOG_OBJECT_NONE = COMBATLOG_OBJECT_NONE	
	local PS_COMBATLOG_FILTER_ENEMY_PLAYERS = bit.bor (COMBATLOG_OBJECT_AFFILIATION_MASK, COMBATLOG_OBJECT_REACTION_MASK, COMBATLOG_OBJECT_CONTROL_PLAYER, COMBATLOG_OBJECT_TYPE_PLAYER);
	local PS_COMBATLOG_FILTER_ENEMY_NPC = bit.bor (COMBATLOG_OBJECT_AFFILIATION_MASK, COMBATLOG_OBJECT_REACTION_MASK, COMBATLOG_OBJECT_CONTROL_PLAYER, COMBATLOG_OBJECT_TYPE_PLAYER, COMBATLOG_OBJECT_CONTROL_NPC, COMBATLOG_OBJECT_TYPE_NPC);
	local PS_msg = "";
	local PS_msg_emote = "";
	local PS_timer_reset_control;

	if (event=="COMBAT_LOG_EVENT_UNFILTERED") then
      if (eventType=="SPELL_DAMAGE" or eventType=="RANGE_DAMAGE" or eventType=="SPELL_PERIODIC_DAMAGE" or eventType=="SPELL_BUILDING_DAMAGE") then
     	 local overkill = select(16, ...)
     	 if overkill and overkill > 0 then
				if(dstName == pname and srcName ~= pname) then
					enemyname = srcName;
					--DEFAULT_CHAT_FRAME:AddMessage(srcName.." "..Killone..pname.."!",1,1,0);
				elseif(dstName == pname and srcName == pname) then
					DEFAULT_CHAT_FRAME:AddMessage(pname.." "..killyourself,1,1,0);
					PS_timer_reset_control = true;
					PS_msg_end = nil;
					enemyname = nil;
				end
		end
      elseif eventType=="SWING_DAMAGE" then
    	local overkill = select(13, ...)
    	if overkill and overkill > 0 then
				if(dstName == pname and srcName ~= pname) then
					enemyname = srcName;
					--DEFAULT_CHAT_FRAME:AddMessage(srcName.." "..Killone..pname.."!",1,1,0);
				elseif(dstName == pname and srcName == pname) then
					DEFAULT_CHAT_FRAME:AddMessage(pname.." "..killyourself,1,1,0);
					PS_timer_reset_control = true;
					PS_msg_end = nil;
					enemyname = nil;
				end
		end
	  elseif eventType=="ENVIRONMENTAL_DAMAGE" then
    	local overkill = select(14, ...)
    	if overkill and overkill > 0 then
				if(dstName == pname and srcName ~= pname) then
					enemyname = srcName;
					--DEFAULT_CHAT_FRAME:AddMessage(srcName.." "..Killone..pname.."!",1,1,0);
				elseif(dstName == pname and srcName == pname) then
					DEFAULT_CHAT_FRAME:AddMessage(pname.." "..killyourself,1,1,0);
					PS_timer_reset_control = true;
					PS_msg_end = nil;
					enemyname = nil;
				end
		end
     end
  end
  
  if event == "PLAYER_DEAD" then
  	if PS_timer_reset_control == true then
			PS_timer_reset = PS_timer_reset;
		else
			PS_timer_reset = true;
			PS_timer_reset_control = false;
		end
		if PS_msg_end and PS_kills > 2 and enemyname then
			DEFAULT_CHAT_FRAME:AddMessage(enemyname..text2..pname..de..PS_msg_end..PS_kills_msg.."！！！",1,1,0);
			--DEFAULT_CHAT_FRAME:AddMessage(pname..de..PS_msg_end..text4..text2,1,1,0);
			PS_msg_end = nil;
			enemyname = nil;
		elseif enemyname then
			DEFAULT_CHAT_FRAME:AddMessage(enemyname.." "..Killone..pname.."！",1,1,0);
			enemyname = nil;
		end
	end
	
	if event == "ADDON_LOADED" then
		if PS_showemote_init == PS_showemote then
			PS_showemote = false
		else
			PS_showemote = true
		end
		if PS_pvpmode_init == PS_pvpmode then
			PS_pvpmode = true
		else
			PS_pvpmode = false
		end
	end
	
	if event == "ZONE_CHANGED_NEW_AREA" then
		local PS_zone = GetZoneText();
		if  (PS_zone == BG_WG or PS_zone == BG_ES or PS_zone == BG_AB or PS_zone == BG_AV or PS_zone == BG_IC or PS_zone == SA or PS_zone == GG_RL or PS_zone == GG_BEA or PS_zone == GG_NA or PS_zone == GG_AG or PS_zone == DA) then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\PrepareForBattle.mp3");
		end
			PS_timer_reset = true;
			PS_msg_end = nil;
	end

	--see if its to an enemy
	local toEnemy
	local toEnemyPlayer
	local toEnemyNPC
	if (dstName and not CombatLog_Object_IsA(dstFlags, COMBATLOG_OBJECT_NONE) ) then
		toEnemyPlayer = CombatLog_Object_IsA(dstFlags, PS_COMBATLOG_FILTER_ENEMY_PLAYERS)
		toEnemyNPC = CombatLog_Object_IsA(dstFlags, PS_COMBATLOG_FILTER_ENEMY_NPC)
	end

	if PS_pvpmode == true then
		toEnemy = toEnemyPlayer;
	else
		toEnemy = toEnemyNPC;
	end

	--if not from a event type we care about, then end
    if (eventType == "PARTY_KILL" and srcGUID == player and toEnemy ) then
			--killing
			if PS_showemote == true then
					SendChatMessage(Killone ..dstName .."!", "EMOTE");
				else
					DEFAULT_CHAT_FRAME:AddMessage(srcName.." "..Killone..dstName.."！",1,1,0);
				end
			if (not PS_lastkill or (GetTime() - PS_lastkill > PS_reset_time ) or PS_timer_reset) then
        PS_msg = MSG_FirstBlood;
				PS_msg_emote = nil;
        PS_file = "firstblood.mp3";
				PS_kills = 1;
				PS_mkills = 1;
				PS_timer_reset = false;
				--PS_msg_end = "测试"
			elseif (GetTime() - PS_lastkill <= PS_reset_time ) then
				PS_kills = PS_kills + 1;
				
				-- multikill
				if (GetTime() - PS_lastkill <= PS_mkill_time) then
						PS_firstmkill = PS_lastkill;
						
						if (PS_kills == 3) then
							PS_file = "killingspree.mp3"
                   					PS_msg = MSG_KillingSpree
							PS_msg_emote = MSG_KillingSpree_E
							PS_msg_end = MSG_KillingSpree_end
						elseif (PS_kills == 4) then
							PS_file = "dominating.mp3"
                   					PS_msg = MSG_Dominating
							PS_msg_emote = MSG_Dominating_E
							PS_msg_end = MSG_Dominating_end
						elseif (PS_kills == 5) then
							PS_file = "megakill.mp3"
                   					PS_msg = MSG_MegaKill
							PS_msg_emote = MSG_MegaKill_E
							PS_msg_end = MSG_MegaKill_end
						elseif (PS_kills == 6) then
							PS_file = "unstoppable.mp3"
                   					PS_msg = MSG_Unstoppable
							PS_msg_emote = MSG_Unstoppable_E
							PS_msg_end = MSG_Unstoppable_end
						elseif (PS_kills == 7) then
							PS_file = "wickedsick.mp3"
                   					PS_msg = MSG_WickedSick
							PS_msg_emote = MSG_WickedSick_E
							PS_msg_end = MSG_WickedSick_end
						elseif (PS_kills == 8) then
							PS_file = "monsterkill.mp3"
                   					PS_msg = MSG_MonsterKill
							PS_msg_emote = MSG_MonsterKill_E
							PS_msg_end = MSG_MonsterKill_end
						elseif (PS_kills == 9) then
							PS_file = "godlike.mp3"
                   					PS_msg = MSG_Godlike
							PS_msg_emote = MSG_Godlike_E
							PS_msg_end = MSG_Godlike_end
						elseif (PS_kills > 9) then
							PS_file = "holyshit.mp3"
                   					PS_msg = MSG_BeyondGod
							PS_msg_emote = MSG_BeyondGod_E
							PS_msg_end = MSG_BeyondGod_end
						else
							PS_file = ""
                   					PS_msg = nil
							PS_msg_emote = nil
							PS_msg_end = nil
						end
						
						if PS_kills >= 10 then
							PS_kills_msg2 = "(x" .. PS_kills .. ")";
						else
							PS_kills_msg2 = "";
						end
						if PS_msg ~= nil or PS_msg_emote ~= nil then
							if PS_showemote == true then
								SendChatMessage(PS_msg_emote..PS_kills_msg2, "EMOTE");
							else
								DEFAULT_CHAT_FRAME:AddMessage(srcName.." "..PS_msg..PS_kills_msg2,1,1,0);
							end
						end

						if (GetTime() - PS_firstmkill <= PS_mkill_time) then
								PS_mkills = PS_mkills + 1;
									if (PS_mkills == 2) then
										PS_file_m = "doublekill.mp3";
                   								PS_msg = MSG_DoubleKill;
										PS_msg_emote = MSG_DoubleKill_E;
									elseif (PS_mkills == 3) then
										PS_file_m = "triplekill.mp3";
                   								PS_msg = MSG_TripleKill;
										PS_msg_emote = MSG_TripleKill_E;
									elseif (PS_mkills == 4) then
										PS_file_m = "UltraKill.mp3";
                   								PS_msg = MSG_MultiKill;
										PS_msg_emote = MSG_MultiKill_E;
									elseif (PS_mkills == 5) then
										PS_file_m = "Rampage.mp3";
                   								PS_msg = MSG_UltraKill;
										PS_msg_emote = MSG_UltraKill_E;
									elseif (PS_mkills > 5) then
										PS_file_m = "Rampage.mp3";
                   								PS_msg = MSG_Flawless;
										PS_msg_emote = MSG_Flawless_E;
									else
										PS_file_m = "";
                   								PS_msg = nil;
										PS_msg_emote = nil;
									end
						end
				else
					PS_mkills = 1
					if (PS_kills == 3) then
						PS_file = "killingspree.mp3"
                   				PS_msg = MSG_KillingSpree
						PS_msg_emote = MSG_KillingSpree_E
						PS_msg_end = MSG_KillingSpree_end
					elseif (PS_kills == 4) then
						PS_file = "dominating.mp3"
                   				PS_msg = MSG_Dominating
						PS_msg_emote = MSG_Dominating_E
						PS_msg_end = MSG_Dominating_end
					elseif (PS_kills == 5) then
						PS_file = "megakill.mp3"
                   				PS_msg = MSG_MegaKill
						PS_msg_emote = MSG_MegaKill_E
						PS_msg_end = MSG_MegaKill_end
					elseif (PS_kills == 6) then
						PS_file = "unstoppable.mp3"
                   				PS_msg = MSG_Unstoppable
						PS_msg_emote = MSG_Unstoppable_E
						PS_msg_end = MSG_Unstoppable_end
					elseif (PS_kills == 7) then
						PS_file = "wickedsick.mp3"
                   				PS_msg = MSG_WickedSick
						PS_msg_emote = MSG_WickedSick_E
						PS_msg_end = MSG_WickedSick_end
					elseif (PS_kills == 8) then
						PS_file = "monsterkill.mp3"
                   				PS_msg = MSG_MonsterKill
						PS_msg_emote = MSG_MonsterKill_E
						PS_msg_end = MSG_MonsterKill_end
					elseif (PS_kills == 9) then
						PS_file = "godlike.mp3"
                   				PS_msg = MSG_Godlike
						PS_msg_emote = MSG_Godlike_E
						PS_msg_end = MSG_Godlike_end
					elseif (PS_kills > 9) then
						PS_file = "holyshit.mp3"
                   				PS_msg = MSG_BeyondGod
						PS_msg_emote = MSG_BeyondGod_E
						PS_msg_end = MSG_BeyondGod_end
					else
						PS_file = ""
                   				PS_msg = nil
						PS_msg_emote = nil
						PS_msg_end = nil
					end

				end
			end
			if PS_mkills >= 2 then
				PS_mkills_msg = "[x" .. PS_mkills .. "]";
			else
				PS_mkills_msg = "";
			end
			if PS_kills >= 10 then
				PS_kills_msg = "(x" .. PS_kills .. ")";
			else
				PS_kills_msg = "";
			end
			if PS_msg ~= nil or PS_msg_emote ~= nil then
				if PS_mkills_msg ~= "" then 
					if PS_showemote == true and PS_msg_emote then
						SendChatMessage(PS_msg_emote..PS_mkills_msg,"EMOTE");
					else
						DEFAULT_CHAT_FRAME:AddMessage(srcName.." "..PS_msg..PS_mkills_msg,1,1,0);
					end
				else
					if PS_showemote == true and PS_msg_emote then
						SendChatMessage(PS_msg_emote..PS_kills_msg,"EMOTE");
					else
						DEFAULT_CHAT_FRAME:AddMessage(srcName.." "..PS_msg..PS_kills_msg,1,1,0);
					end
				end	
			end
			PS_lastkill = GetTime();
			if PS_kills >=3 and PS_mkills >=2 then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..PS_file);
				PVPSound_frame:SetScript('OnUpdate', PVPSound_frame.OnUpdate);
			elseif PS_kills ~= nil and PS_mkills == 1 then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..PS_file);
			elseif PS_kills == 2 and PS_mkills ~= nil then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..PS_file_m);
			end
	else
		return;
	end
end

PVPSound_frame:SetScript("OnEvent", PVPSound_OnEvent);

function PVPSound_Command(arg1)
	arg1 = strlower(arg1)
	if arg1 == "emote" then
		PS_showemote = not PS_showemote;
		if PS_showemote == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_ShowEmote .. "：" .. Opt_Enable,1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_ShowEmote .. "：" .. Opt_Disable,1,1,0);
		end
	elseif arg1 == "pvp" then
		PS_pvpmode = not PS_pvpmode;
		if PS_pvpmode == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_PVPMode,1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_PVEMode,1,1,0);
		end
	elseif arg1 == "reset" then
			PS_timer_reset = true;
			DEFAULT_CHAT_FRAME:AddMessage(Opt_reset,1,1,0);
	elseif arg1 == "help" then
		DEFAULT_CHAT_FRAME:AddMessage("PVPSound " .. GetAddOnMetadata("PVPSound", "Version") .. " " .. Opt_cmdlist,0,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/psd ——————" .. Opt_helpstatus,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/psd pvp ————" .. Opt_helpmode,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/psd emote ———" .. Opt_helpshowemote,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/psd reset ———" .. Opt_helpreset,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/psd help ———" .. Opt_helpcmdlist,1,1,0);
	else
		DEFAULT_CHAT_FRAME:AddMessage("PVPSound " .. GetAddOnMetadata("PVPSound", "Version") .. " " .. Opt_helpinput,0,1,0);
			DEFAULT_CHAT_FRAME:AddMessage(Opt_kills .. "："..PS_kills,1,1,0);
		if PS_pvpmode == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_PVPMode,1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_PVEMode,1,1,0);
		end
		if PS_showemote == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_ShowEmote .. "：" .. Opt_Enable,1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_ShowEmote .. "：" .. Opt_Disable,1,1,0);
		end
	end
end

